package com.heyu.api.controller.vv;


import com.alibaba.fastjson.JSON;
import com.heyu.api.alibaba.request.vv.AppQrCodeRequest;
import com.heyu.api.common.annotation.AppRealyLogin;
import com.heyu.api.common.annotation.Describe;
import com.heyu.api.data.dto.AccessTokenDTO;
import com.heyu.api.data.utils.HttpUtils;
import com.heyu.api.data.utils.R;
import com.heyu.api.data.utils.WeChatUtils;
import com.heyu.api.oss.OssFileUploadService;
import com.heyu.api.oss.OssUploadResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.Map;

@Slf4j
@RestController
@RequestMapping("/app/qrcode")
public class AppQrCodeController {


    // 自行配置：正式版为 "release"，体验版为 "trial"，开发版为 "develop"。默认是正式版。
    private String envVersion = "trial";


    @Autowired
    private OssFileUploadService ossFileUploadService;


    @Autowired
    private WeChatUtils weChatUtils;

    /***
     * 列表
     * http://localhost:8888/app/qrcode/create
     *
     * https://developers.weixin.qq.com/miniprogram/dev/OpenApiDoc/qrcode-link/qr-code/getUnlimitedQRCode.html
     *
     */
    @Describe("生成二维码")
    @RequestMapping("/create")
    @AppRealyLogin
    public R create(@RequestBody AppQrCodeRequest request) {

        AccessTokenDTO accessTokenDTO = weChatUtils.getAccessTokenDTO(true);
        // 当前登录账号
        String accountId = "123456";

        String url = WeChatUtils.wechatQrcodeUrl + accessTokenDTO.getAccessToken();

        Map<String, Object> body = new HashMap<>();
        // 场景码，请根据业务场景与【前端】约定
        // 最大32个可见字符，只支持数字，大小写英文以及部分特殊字符：!#$&'()*+,/:;=?@-._~，其它字符请自行编码为合法字符（因不支持%，中文无法使用 urlencode 处理，请使用其他编码方式）
        body.put("scene", String.format("a=%s", accountId));
        body.put("env_version", envVersion);
        // body.put("page", envVersion); 默认是主页，页面 page，例如 pages/index/index，根路径前不要填加 /，不能携带参数（参数请放在scene字段里），如果不填写这个字段，默认跳主页面。scancode_time为系统保留参数，不允许配置
        // 透明
        body.put("is_hyaline", true);  // 默认是false，是否需要透明底色，为 true 时，生成透明底色的小程序



        log.info("AppQrCodeController create qr code url : {},body:{} ",url , JSON.toJSONString(body));


        byte[] bytes = HttpUtils.getWechatQrcodeByHttpURL(url, body);

        if (bytes == null) {
            return R.error("bytes is null");
        }

        String error = new String(bytes);

        if (error.contains("errcode")) {
            return R.error(error);
        }

        OssUploadResult ossUploadResult = ossFileUploadService.uploadImageByBytes(bytes);
        return R.ok().setData(ossUploadResult);
    }

}
